package org.postgresql.jdbc2;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
//import java.util.StringTokenizer;
import java.util.*;
import org.postgresql.Driver;
import org.postgresql.Field;
import org.postgresql.util.PSQLException;

// Referenced classes of package org.postgresql.jdbc2:
//            Connection, ResultSet

public class DatabaseMetaData
    implements java.sql.DatabaseMetaData
{
    org.postgresql.jdbc2.Connection connection;
    static final int iVarcharOid = 1043;
    static final int iBoolOid = 16;
    static final int iInt2Oid = 21;
    static final int iInt4Oid = 23;
    static final int VARHDRSZ = 4;
    private static final String getTableTypes[][] = 
    {
        {
            "TABLE", "(relkind='r' and relhasrules='f' and relname !~ '^pg_' and relname !~ '^xinv')"
        }, {
            "VIEW", "(relkind='v' and relname !~ '^pg_')"
        }, {
            "INDEX", "(relkind='i' and relname !~ '^pg_')"
        }, {
            "SEQUENCE", "(relkind='S' and relname !~ '^pg_')"
        }, {
            "SYSTEM TABLE", "(relkind='r' and relname ~ '^pg_')"
        }, {
            "SYSTEM INDEX", "(relkind='i' and relname ~ '^pg_')"
        }
    };
    
    private static final Hashtable m_htNotSuportedTableTypes=new Hashtable(3);
    static
    {
        m_htNotSuportedTableTypes.put("ALIAS","ALIAS");
        m_htNotSuportedTableTypes.put("SYNONYM","SYNONYM");
        m_htNotSuportedTableTypes.put("GLOBAL TEMPORARY","GLOBAL TEMPORARY");
        m_htNotSuportedTableTypes.put("LOCAL TEMPORARY","LOCAL TEMPORARY");
    }
    
    
    private static final String defaultTableTypes[] = {
        "TABLE", "VIEW", "INDEX", "SEQUENCE"
    };

    public DatabaseMetaData(org.postgresql.jdbc2.Connection connection1)
    {
        connection = connection1;
    }

    public boolean allProceduresAreCallable()
        throws SQLException
    {
        Driver.debug("allProceduresAreCallable");
        return true;
    }

    public boolean allTablesAreSelectable()
        throws SQLException
    {
        Driver.debug("allTablesAreSelectable");
        return true;
    }

    public boolean dataDefinitionCausesTransactionCommit()
        throws SQLException
    {
        return false;
    }

    public boolean dataDefinitionIgnoredInTransactions()
        throws SQLException
    {
        return true;
    }

    public boolean deletesAreDetected(int i)
        throws SQLException
    {
        return false;
    }

    public boolean doesMaxRowSizeIncludeBlobs()
        throws SQLException
    {
        return false;
    }

    public ResultSet getBestRowIdentifier(String s, String s1, String s2, int i, boolean flag)
        throws SQLException
    {
        Field afield[] = new Field[8];
        Vector vector = new Vector();
        afield[0] = new Field(connection, "SCOPE", 21, 2);
        afield[1] = new Field(connection, "COLUMN_NAME", 1043, 32);
        afield[2] = new Field(connection, "DATA_TYPE", 21, 2);
        afield[3] = new Field(connection, "TYPE_NAME", 1043, 32);
        afield[4] = new Field(connection, "COLUMN_SIZE", 23, 4);
        afield[5] = new Field(connection, "BUFFER_LENGTH", 23, 4);
        afield[6] = new Field(connection, "DECIMAL_DIGITS", 21, 2);
        afield[7] = new Field(connection, "PSEUDO_COLUMN", 21, 2);
        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public String getCatalogSeparator()
        throws SQLException
    {
        Driver.debug("getCatalogSeparator not implemented ");
        return ".";
    }

    public String getCatalogTerm()
        throws SQLException
    {
        Driver.debug("getCatalogTerm database ");
        return "database";
    }

    public ResultSet getCatalogs()
        throws SQLException
    {
        return connection.createStatement().executeQuery("select datname as TABLE_CAT from pg_database;");
    }

    public ResultSet getColumnPrivileges(String s, String s1, String s2, String s3)
        throws SQLException
    {
        Field afield[] = new Field[8];
        Vector vector = new Vector();
        if(s2 == null)
            s2 = "%";
        if(s3 == null)
            s3 = "%";
        else
            s3 = s3.toLowerCase();
        afield[0] = new Field(connection, "TABLE_CAT", 1043, 32);
        afield[1] = new Field(connection, "TABLE_SCHEM", 1043, 32);
        afield[2] = new Field(connection, "TABLE_NAME", 1043, 32);
        afield[3] = new Field(connection, "COLUMN_NAME", 1043, 32);
        afield[4] = new Field(connection, "GRANTOR", 1043, 32);
        afield[5] = new Field(connection, "GRANTEE", 1043, 32);
        afield[6] = new Field(connection, "PRIVILEGE", 1043, 32);
        afield[7] = new Field(connection, "IS_GRANTABLE", 1043, 32);
        for(ResultSet resultset = connection.ExecSQL("SELECT relname, relacl FROM pg_class, pg_user WHERE ( relkind = 'r' OR relkind = 'i') and relname !~ '^pg_' and relname !~ '^xin[vx][0-9]+' and usesysid = relowner and relname like '" + s2.toLowerCase() + "' ORDER BY relname"); resultset.next(); DriverManager.println("relname=\"" + resultset.getString(1) + "\" relacl=\"" + resultset.getString(2) + "\""))
        {
            byte abyte0[][] = new byte[8][0];
            abyte0[0] = abyte0[1] = "".getBytes();
        }

        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public ResultSet getColumns(String s, String s1, String s2, String s3)
        throws SQLException
    {
        Vector vector = new Vector();
        Field afield[] = new Field[18];
        afield[0] = new Field(connection, "TABLE_CAT", 1043, 32);
        afield[1] = new Field(connection, "TABLE_SCHEM", 1043, 32);
        afield[2] = new Field(connection, "TABLE_NAME", 1043, 32);
        afield[3] = new Field(connection, "COLUMN_NAME", 1043, 32);
        afield[4] = new Field(connection, "DATA_TYPE", 21, 2);
        afield[5] = new Field(connection, "TYPE_NAME", 1043, 32);
        afield[6] = new Field(connection, "COLUMN_SIZE", 23, 4);
        afield[7] = new Field(connection, "BUFFER_LENGTH", 1043, 32);
        afield[8] = new Field(connection, "DECIMAL_DIGITS", 23, 4);
        afield[9] = new Field(connection, "NUM_PREC_RADIX", 23, 4);
        afield[10] = new Field(connection, "NULLABLE", 23, 4);
        afield[11] = new Field(connection, "REMARKS", 1043, 32);
        afield[12] = new Field(connection, "COLUMN_DEF", 1043, 32);
        afield[13] = new Field(connection, "SQL_DATA_TYPE", 23, 4);
        afield[14] = new Field(connection, "SQL_DATETIME_SUB", 23, 4);
        afield[15] = new Field(connection, "CHAR_OCTET_LENGTH", 1043, 32);
        afield[16] = new Field(connection, "ORDINAL_POSITION", 23, 4);
        afield[17] = new Field(connection, "IS_NULLABLE", 1043, 32);
        StringBuffer stringbuffer = new StringBuffer(512);
        stringbuffer.append("select " + (connection.haveMinimumServerVersion("7.2") ? "a.attrelid, " : "a.oid, ") + "    c.relname, " + "    a.attname, " + "    a.atttypid, " + "    a.attnum, " + "    a.attnotnull, " + "    a.attlen, " + "    a.atttypmod, " + "    d.adsrc, " + "    t.typname, " + (connection.haveMinimumServerVersion("7.2") ? "col_description(a.attrelid, a.attnum) " : "e.description ") + "from" + "    (" + "        (pg_class c inner join pg_attribute a on" + "            (" + "                a.attrelid=c.oid");
        if(s2 != null && !s2.equals("%"))
            stringbuffer.append("                and c.relname like '" + s2 + "'");
        if(s3 != null && !s3.equals("%"))
            stringbuffer.append("                and a.attname like '" + s3 + "'");
        stringbuffer.append("                and a.attnum > 0            )        ) inner join pg_type t on            (                t.oid = a.atttypid            )    )    left outer join pg_attrdef d on        (            c.oid = d.adrelid            and a.attnum = d.adnum        ) ");
        if(!connection.haveMinimumServerVersion("7.2"))
            stringbuffer.append("    left outer join pg_description e on        (            e.objoid = a.oid        ) ");
        stringbuffer.append("order by    c.relname, a.attnum");
        ResultSet resultset;
        byte abyte0[][];
        for(resultset = connection.ExecSQL(stringbuffer.toString()); resultset.next(); vector.addElement(abyte0))
        {
            abyte0 = new byte[18][0];
            String s4 = resultset.getString(6);
            String s5 = resultset.getString(10);
            abyte0[0] = null;
            abyte0[1] = null;
            abyte0[2] = resultset.getBytes(2);
            abyte0[3] = resultset.getBytes(3);
            abyte0[4] = Integer.toString(connection.getSQLType(s5)).getBytes();
            abyte0[5] = s5.getBytes();
            if(s5.equals("bpchar") || s5.equals("varchar"))
            {
                int i = resultset.getInt(8);
                abyte0[6] = Integer.toString(i == -1 ? 0 : i - 4).getBytes();
            } else
            {
                abyte0[6] = resultset.getBytes(7);
            }
            abyte0[7] = null;
            if(s5.equals("numeric") || s5.equals("decimal"))
            {
                int j = resultset.getInt(8);
                abyte0[8] = Integer.toString(j - 4 & 0xffff).getBytes();
            } else
            {
                abyte0[8] = "0".getBytes();
            }
            abyte0[9] = "10".getBytes();
            abyte0[10] = Integer.toString(s4.equals("f") ? 1 : 0).getBytes();
            abyte0[11] = resultset.getBytes(11);
            abyte0[12] = resultset.getBytes(9);
            abyte0[13] = null;
            abyte0[14] = null;
            abyte0[15] = abyte0[6];
            abyte0[16] = resultset.getBytes(5);
            abyte0[17] = (s4.equals("f") ? "YES" : "NO").getBytes();
        }

        resultset.close();
        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public Connection getConnection()
        throws SQLException
    {
        return connection;
    }

    public ResultSet getCrossReference(String s, String s1, String s2, String s3, String s4, String s5)
        throws SQLException
    {
        return getImportedExportedKeys(s, s1, s2, s5);
    }

    public String getDatabaseProductName()
        throws SQLException
    {
        Driver.debug("getDatabaseProductName PostgresSQL");
        return "PostgreSQL";
    }

    public String getDatabaseProductVersion()
        throws SQLException
    {
        String s = connection.getDBVersionNumber();
        Driver.debug("getDatabaseProductVersion " + s);
        return s;
    }

    public int getDefaultTransactionIsolation()
        throws SQLException
    {
        return 2;
    }

    public int getDriverMajorVersion()
    {
        int i = ((org.postgresql.Connection) (connection)).this_driver.getMajorVersion();
        Driver.debug("getMajorVersion " + i);
        return i;
    }

    public int getDriverMinorVersion()
    {
        int i = ((org.postgresql.Connection) (connection)).this_driver.getMinorVersion();
        Driver.debug("getMinorVersion " + i);
        return i;
    }

    public String getDriverName()
        throws SQLException
    {
        String s = "PostgreSQL Native Driver";
        Driver.debug("getDriverName" + s);
        return s;
    }

    public String getDriverVersion()
        throws SQLException
    {
        Driver _tmp = ((org.postgresql.Connection) (connection)).this_driver;
        String s = Driver.getVersion();
        Driver.debug("getDriverVersion " + s);
        return s;
    }

    public ResultSet getExportedKeys(String s, String s1, String s2)
        throws SQLException
    {
        return getImportedExportedKeys(s, s1, s2, null);
    }

    public String getExtraNameCharacters()
        throws SQLException
    {
        Driver.debug("getExtraNameCharacters");
        return "";
    }

    public String getIdentifierQuoteString()
        throws SQLException
    {
        Driver.debug("getIdentifierQuoteString \"");
        return "\"";
    }

    private ResultSet getImportedExportedKeys(String s, String s1, String s2, String s3)
        throws SQLException
    {
        Field afield[] = new Field[14];
        afield[0] = new Field(connection, "PKTABLE_CAT", 1043, 32);
        afield[1] = new Field(connection, "PKTABLE_SCHEM", 1043, 32);
        afield[2] = new Field(connection, "PKTABLE_NAME", 1043, 32);
        afield[3] = new Field(connection, "PKCOLUMN_NAME", 1043, 32);
        afield[4] = new Field(connection, "FKTABLE_CAT", 1043, 32);
        afield[5] = new Field(connection, "FKTABLE_SCHEM", 1043, 32);
        afield[6] = new Field(connection, "FKTABLE_NAME", 1043, 32);
        afield[7] = new Field(connection, "FKCOLUMN_NAME", 1043, 32);
        afield[8] = new Field(connection, "KEY_SEQ", 21, 2);
        afield[9] = new Field(connection, "UPDATE_RULE", 21, 2);
        afield[10] = new Field(connection, "DELETE_RULE", 21, 2);
        afield[11] = new Field(connection, "FK_NAME", 1043, 32);
        afield[12] = new Field(connection, "PK_NAME", 1043, 32);
        afield[13] = new Field(connection, "DEFERRABILITY", 21, 2);
        ResultSet resultset = connection.ExecSQL("SELECT c.relname,c2.relname,t.tgconstrname,ic.relname,t.tgdeferrable,t.tginitdeferred,t.tgnargs,t.tgargs,p.proname FROM pg_trigger t,pg_class c,pg_class c2,pg_class ic,pg_proc p, pg_index i WHERE t.tgrelid=c.oid AND t.tgconstrrelid=c2.oid AND t.tgfoid=p.oid AND tgisconstraint " + (s2 == null ? "" : "AND c.relname='" + s2 + "' ") + (s3 == null ? "" : "AND c2.relname='" + s3 + "' ") + "AND i.indrelid=c.oid " + "AND i.indexrelid=ic.oid AND i.indisprimary " + "ORDER BY c.relname,c2.relname");
        Vector vector = new Vector();
        short word0 = 0;
        boolean flag;
        if(resultset.next())
            do
            {
                byte abyte0[][] = new byte[14][0];
                for(int i = 0; i < 14; i++)
                    abyte0[i] = null;

                String s4 = resultset.getString(3);
                boolean flag1 = false;
                do
                {
                    String s5 = resultset.getString(9);
                    if(s5 != null && s5.startsWith("RI_FKey_"))
                    {
                        byte byte0 = -1;
                        if(s5.endsWith("_upd"))
                            byte0 = 9;
                        else
                        if(s5.endsWith("_del"))
                            byte0 = 10;
                        if(byte0 > -1)
                        {
                            String s6 = s5.substring(8, s5.length() - 4);
                            byte byte1 = 3;
                            if("cascade".equals(s6))
                                byte1 = 0;
                            else
                            if("setnull".equals(s6))
                                byte1 = 2;
                            else
                            if("setdefault".equals(s6))
                                byte1 = 4;
                            abyte0[byte0] = Integer.toString(byte1).getBytes();
                            if(!flag1)
                            {
                                abyte0[2] = resultset.getBytes(1);
                                abyte0[6] = resultset.getBytes(2);
                                StringBuffer stringbuffer = new StringBuffer();
                                StringBuffer stringbuffer1 = new StringBuffer();
                                int j = (resultset.getInt(7) >> 1) - 2;
                                String s7 = resultset.getString(8);
                                int k = s7.lastIndexOf("\\000");
                                for(int l = 0; l < j; l++)
                                    if(k > -1)
                                    {
                                        int i1 = s7.lastIndexOf("\\000", k - 1);
                                        if(i1 > -1)
                                        {
                                            if(stringbuffer1.length() > 0)
                                                stringbuffer1.insert(0, ',');
                                            stringbuffer1.insert(0, s7.substring(i1 + 4, k));
                                            k = s7.lastIndexOf("\\000", i1 - 1);
                                            if(k > -1)
                                            {
                                                if(stringbuffer.length() > 0)
                                                    stringbuffer.insert(0, ',');
                                                stringbuffer.insert(0, s7.substring(k + 4, i1));
                                            }
                                        }
                                    }

                                abyte0[3] = stringbuffer1.toString().getBytes();
                                abyte0[7] = stringbuffer.toString().getBytes();
                                abyte0[8] = Integer.toString(word0++).getBytes();
                                abyte0[11] = s4.getBytes();
                                abyte0[12] = resultset.getBytes(4);
                                byte byte2 = 7;
                                boolean flag2 = resultset.getBoolean(5);
                                boolean flag3 = resultset.getBoolean(6);
                                if(flag2)
                                    if(flag3)
                                        byte2 = 5;
                                    else
                                        byte2 = 6;
                                abyte0[13] = Integer.toString(byte2).getBytes();
                                flag1 = true;
                            }
                        }
                    }
                } while((flag = resultset.next()) && s4.equals(resultset.getString(3)));
                if(flag1)
                    vector.addElement(abyte0);
            } while(flag);
        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public ResultSet getImportedKeys(String s, String s1, String s2)
        throws SQLException
    {
        return getImportedExportedKeys(s, s1, null, s2);
    }

    public ResultSet getIndexInfo(String s, String s1, String s2, boolean flag, boolean flag1)
        throws SQLException
    {
        Field afield[] = new Field[13];
        Vector vector = new Vector();
        afield[0] = new Field(connection, "TABLE_CAT", 1043, 32);
        afield[1] = new Field(connection, "TABLE_SCHEM", 1043, 32);
        afield[2] = new Field(connection, "TABLE_NAME", 1043, 32);
        afield[3] = new Field(connection, "NON_UNIQUE", 16, 1);
        afield[4] = new Field(connection, "INDEX_QUALIFIER", 1043, 32);
        afield[5] = new Field(connection, "INDEX_NAME", 1043, 32);
        afield[6] = new Field(connection, "TYPE", 21, 2);
        afield[7] = new Field(connection, "ORDINAL_POSITION", 21, 2);
        afield[8] = new Field(connection, "COLUMN_NAME", 1043, 32);
        afield[9] = new Field(connection, "ASC_OR_DESC", 1043, 32);
        afield[10] = new Field(connection, "CARDINALITY", 23, 4);
        afield[11] = new Field(connection, "PAGES", 23, 4);
        afield[12] = new Field(connection, "FILTER_CONDITION", 1043, 32);
        for(ResultSet resultset = connection.ExecSQL("select c.relname, x.indisunique, i.relname, x.indisclustered, a.amname, x.indkey, c.reltuples, c.relpages, x.indexrelid FROM pg_index x, pg_class c, pg_class i, pg_am a WHERE ((c.relname = '" + s2.toLowerCase() + "') " + " AND (c.oid = x.indrelid) " + " AND (i.oid = x.indexrelid) " + " AND (i.relam = a.oid)) " + "ORDER BY x.indisunique DESC, " + " x.indisclustered, a.amname, i.relname"); resultset.next();)
        {
            String s3 = resultset.getString(6);
            StringTokenizer stringtokenizer = new StringTokenizer(s3);
            int ai[] = new int[stringtokenizer.countTokens()];
            int i = 0;
            while(stringtokenizer.hasMoreTokens()) 
                ai[i++] = Integer.parseInt(stringtokenizer.nextToken());
            for(int j = 0; j < ai.length; j++)
            {
                byte abyte0[][] = new byte[13][];
                abyte0[0] = "".getBytes();
                abyte0[1] = "".getBytes();
                abyte0[2] = resultset.getBytes(1);
                abyte0[3] = resultset.getBoolean(2) ? "false".getBytes() : "true".getBytes();
                abyte0[4] = null;
                abyte0[5] = resultset.getBytes(3);
                abyte0[6] = resultset.getBoolean(4) ? Integer.toString(1).getBytes() : resultset.getString(5).equals("hash") ? Integer.toString(2).getBytes() : Integer.toString(3).getBytes();
                abyte0[7] = Integer.toString(j + 1).getBytes();
                ResultSet resultset1 = connection.ExecSQL("select a.attname FROM pg_attribute a WHERE (a.attnum = " + ai[j] + ") AND (a.attrelid = " + resultset.getInt(9) + ")");
                if(resultset1.next())
                    abyte0[8] = resultset1.getBytes(1);
                else
                    abyte0[8] = "".getBytes();
                abyte0[8] = resultset1.getBytes(1);
                abyte0[9] = null;
                abyte0[10] = resultset.getBytes(7);
                abyte0[11] = resultset.getBytes(8);
                abyte0[12] = null;
                vector.addElement(abyte0);
            }

        }

        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public int getMaxBinaryLiteralLength()
        throws SQLException
    {
        return 0;
    }

    public int getMaxCatalogNameLength()
        throws SQLException
    {
        return 0;
    }

    public int getMaxCharLiteralLength()
        throws SQLException
    {
        return 0;
    }

    public int getMaxColumnNameLength()
        throws SQLException
    {
        return 32;
    }

    public int getMaxColumnsInGroupBy()
        throws SQLException
    {
        return 0;
    }

    public int getMaxColumnsInIndex()
        throws SQLException
    {
        return getMaxColumnsInTable();
    }

    public int getMaxColumnsInOrderBy()
        throws SQLException
    {
        return 0;
    }

    public int getMaxColumnsInSelect()
        throws SQLException
    {
        return 0;
    }

    public int getMaxColumnsInTable()
        throws SQLException
    {
        return 1600;
    }

    public int getMaxConnections()
        throws SQLException
    {
        return 8192;
    }

    public int getMaxCursorNameLength()
        throws SQLException
    {
        return 32;
    }

    public int getMaxIndexLength()
        throws SQLException
    {
        return 0;
    }

    public int getMaxProcedureNameLength()
        throws SQLException
    {
        return 32;
    }

    public int getMaxRowSize()
        throws SQLException
    {
        return !connection.haveMinimumServerVersion("7.1") ? 8192 : 0x40000000;
    }

    public int getMaxSchemaNameLength()
        throws SQLException
    {
        return 0;
    }

    public int getMaxStatementLength()
        throws SQLException
    {
        return !connection.haveMinimumServerVersion("7.0") ? 16384 : 0;
    }

    public int getMaxStatements()
        throws SQLException
    {
        return 1;
    }

    public int getMaxTableNameLength()
        throws SQLException
    {
        return 32;
    }

    public int getMaxTablesInSelect()
        throws SQLException
    {
        return 0;
    }

    public int getMaxUserNameLength()
        throws SQLException
    {
        return 32;
    }

    public String getNumericFunctions()
        throws SQLException
    {
        Driver.debug("getNumericFunctions");
        return "";
    }

    public ResultSet getPrimaryKeys(String s, String s1, String s2)
        throws SQLException
    {
        return connection.createStatement().executeQuery("SELECT '' as TABLE_CAT,'' AS TABLE_SCHEM,bc.relname AS TABLE_NAME,a.attname AS COLUMN_NAME,a.attnum as KEY_SEQ,ic.relname as PK_NAME  FROM pg_class bc, pg_class ic, pg_index i, pg_attribute a WHERE bc.relkind = 'r'   and upper(bc.relname) = upper('" + s2 + "')" + "  and i.indrelid = bc.oid" + "  and i.indexrelid = ic.oid" + "  and ic.oid = a.attrelid" + "  and i.indisprimary='t' " + " ORDER BY table_name, pk_name, key_seq");
    }

    public ResultSet getProcedureColumns(String s, String s1, String s2, String s3)
        throws SQLException
    {
        if(s2 == null)
            s2 = "%";
        if(s3 == null)
            s3 = "%";
        Field afield[] = new Field[13];
        Vector vector = new Vector();
        afield[0] = new Field(connection, "PROCEDURE_CAT", 1043, 32);
        afield[1] = new Field(connection, "PROCEDURE_SCHEM", 1043, 32);
        afield[2] = new Field(connection, "PROCEDURE_NAME", 1043, 32);
        afield[3] = new Field(connection, "COLUMN_NAME", 1043, 32);
        afield[4] = new Field(connection, "COLUMN_TYPE", 21, 2);
        afield[5] = new Field(connection, "DATA_TYPE", 21, 2);
        afield[6] = new Field(connection, "TYPE_NAME", 1043, 32);
        afield[7] = new Field(connection, "PRECISION", 23, 4);
        afield[8] = new Field(connection, "LENGTH", 23, 4);
        afield[9] = new Field(connection, "SCALE", 21, 2);
        afield[10] = new Field(connection, "RADIX", 21, 2);
        afield[11] = new Field(connection, "NULLABLE", 21, 2);
        afield[12] = new Field(connection, "REMARKS", 1043, 32);
        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public String getProcedureTerm()
        throws SQLException
    {
        Driver.debug("getProcedureTerm function ");
        return "function";
    }

    public ResultSet getProcedures(String s, String s1, String s2)
        throws SQLException
    {
        Field afield[] = new Field[8];
        Vector vector = new Vector();
        afield[0] = new Field(connection, "PROCEDURE_CAT", 1043, 32);
        afield[1] = new Field(connection, "PROCEDURE_SCHEM", 1043, 32);
        afield[2] = new Field(connection, "PROCEDURE_NAME", 1043, 32);
        afield[3] = afield[4] = afield[5] = new Field(connection, "reserved", 1043, 32);
        afield[6] = new Field(connection, "REMARKS", 1043, 8192);
        afield[7] = new Field(connection, "PROCEDURE_TYPE", 21, 2);
        if(s2 == null)
            s2 = "%";
        byte abyte0[][];
        for(ResultSet resultset = connection.ExecSQL("select proname, proretset from pg_proc where proname like '" + s2.toLowerCase() + "' order by proname"); resultset.next(); vector.addElement(abyte0))
        {
            abyte0 = new byte[8][0];
            abyte0[0] = null;
            abyte0[1] = null;
            abyte0[2] = resultset.getBytes(1);
            abyte0[3] = abyte0[4] = abyte0[5] = null;
            abyte0[6] = null;
            if(resultset.getBoolean(2))
                abyte0[7] = Integer.toString(2).getBytes();
            else
                abyte0[7] = Integer.toString(1).getBytes();
        }

        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public String getSQLKeywords()
        throws SQLException
    {
        Driver.debug("getSQLKeyWords");
        return "abort,acl,add,aggregate,append,archive,arch_store,backward,binary,change,cluster,copy,database,delimiters,do,extend,explain,forward,heavy,index,inherits,isnull,light,listen,load,merge,nothing,notify,notnull,oids,purge,rename,replace,retrieve,returns,rule,recipe,setof,stdin,stdout,store,vacuum,verbose,version";
    }

    public String getSchemaTerm()
        throws SQLException
    {
        Driver.debug("getSchemaTerm schema");
        return "schema";
    }

    public ResultSet getSchemas()
        throws SQLException
    {
        Field afield[] = new Field[1];
        Vector vector = new Vector();
        byte abyte0[][] = new byte[1][0];
        afield[0] = new Field(connection, "TABLE_SCHEM", 1043, 32);
        abyte0[0] = "".getBytes();
        vector.addElement(abyte0);
        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public String getSearchStringEscape()
        throws SQLException
    {
        Driver.debug("getSearchStringEscape");
        return "\\";
    }

    public String getStringFunctions()
        throws SQLException
    {
        Driver.debug("getStringFunctions");
        return "";
    }

    public String getSystemFunctions()
        throws SQLException
    {
        Driver.debug("getSystemFunctions");
        return "";
    }

    public ResultSet getTablePrivileges(String s, String s1, String s2)
        throws SQLException
    {
        Field afield[] = new Field[8];
        Vector vector = new Vector();
        if(s2 == null)
            s2 = "%";
        afield[0] = new Field(connection, "TABLE_CAT", 1043, 32);
        afield[1] = new Field(connection, "TABLE_SCHEM", 1043, 32);
        afield[2] = new Field(connection, "TABLE_NAME", 1043, 32);
        afield[3] = new Field(connection, "COLUMN_NAME", 1043, 32);
        afield[4] = new Field(connection, "GRANTOR", 1043, 32);
        afield[5] = new Field(connection, "GRANTEE", 1043, 32);
        afield[6] = new Field(connection, "PRIVILEGE", 1043, 32);
        afield[7] = new Field(connection, "IS_GRANTABLE", 1043, 32);
        for(ResultSet resultset = connection.ExecSQL("SELECT relname, relacl FROM pg_class, pg_user WHERE ( relkind = 'r' OR relkind = 'i') and relname !~ '^pg_' and relname !~ '^xin[vx][0-9]+' and usesysid = relowner and relname like '" + s2.toLowerCase() + "' ORDER BY relname"); resultset.next(); DriverManager.println("relname=\"" + resultset.getString(1) + "\" relacl=\"" + resultset.getString(2) + "\""))
        {
            byte abyte0[][] = new byte[8][0];
            abyte0[0] = abyte0[1] = "".getBytes();
        }

        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public ResultSet getTableTypes()
        throws SQLException
    {
        Field afield[] = new Field[1];
        Vector vector = new Vector();
        afield[0] = new Field(connection, new String("TABLE_TYPE"), 1043, 32);
        for(int i = 0; i < getTableTypes.length; i++)
        {
            byte abyte0[][] = new byte[2][0];
            abyte0[0] = getTableTypes[i][0].getBytes();
            vector.addElement(abyte0);
        }

        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public ResultSet getTables(String s, String s1, String s2, String as[])
        throws SQLException
    {
    	boolean booNotSuportedDetected=false;
        if(as == null)
            as = defaultTableTypes;
        if(s2 == null)
            s2 = "%";
        Field afield[] = new Field[5];
        Vector vector = new Vector();
        afield[0] = new Field(connection, "TABLE_CAT", 1043, 32);
        afield[1] = new Field(connection, "TABLE_SCHEM", 1043, 32);
        afield[2] = new Field(connection, "TABLE_NAME", 1043, 32);
        afield[3] = new Field(connection, "TABLE_TYPE", 1043, 32);
        afield[4] = new Field(connection, "REMARKS", 1043, 32);
        String strStartOfQuery="select relname,oid,relkind from pg_class where ";
        StringBuffer stringbuffer = new StringBuffer();//strStartOfQuery);
        boolean flag = false;
        for(int i = 0; i < as.length; i++)
        {
            for(int j = 0; j < getTableTypes.length; j++)
            {
		        if(m_htNotSuportedTableTypes.get(as[i])!=null)
		        {
            		booNotSuportedDetected=true;
            		continue;
            	}
            	
                if(getTableTypes[j][0].equals(as[i]))
                {
                    if(flag)
                        stringbuffer.append(" or ");
                    stringbuffer.append(getTableTypes[j][1]);
                    flag = true;
                }
			}
        }
        String strTmp=stringbuffer.toString();
		if(strTmp==null || "".equals(strTmp.trim()))
		{
			if(booNotSuportedDetected)
				stringbuffer.append(" ( 1=0 ) and ");
	        stringbuffer.append(" relname like '");
		}
		else
		{
			strStartOfQuery+="( ";
	        stringbuffer.append(") and relname like '");
		}
		
        stringbuffer.append(s2.toLowerCase());
        stringbuffer.append("' order by relkind, relname");
        ResultSet resultset;
        byte abyte0[][];
        String strSQL=strStartOfQuery+stringbuffer.toString();
        //System.out.println("strSQL = "+strSQL);
        for(resultset = connection.ExecSQL(strSQL); resultset.next(); vector.addElement(abyte0))
        {
            abyte0 = new byte[5][0];
            String s3 = connection.haveMinimumServerVersion("7.2") ? "select obj_description(" + resultset.getInt(2) + ",'pg_class')" : "select description from pg_description where objoid=" + resultset.getInt(2);
            ResultSet resultset1 = connection.ExecSQL(s3);
            byte abyte1[] = null;
            if(((org.postgresql.ResultSet)resultset1).getTupleCount() == 1)
            {
                resultset1.next();
                abyte1 = resultset1.getBytes(1);
            }
            resultset1.close();
            String s4;
            switch(resultset.getBytes(3)[0])
            {
            case 114: // 'r'
                s4 = "TABLE";
                break;

            case 105: // 'i'
                s4 = "INDEX";
                break;

            case 83: // 'S'
                s4 = "SEQUENCE";
                break;

            case 118: // 'v'
                s4 = "VIEW";
                break;

            default:
                s4 = null;
                break;
            }
            abyte0[0] = null;
            abyte0[1] = null;
            abyte0[2] = resultset.getBytes(1);
            abyte0[3] = s4 != null ? s4.getBytes() : null;
            abyte0[4] = abyte1;
        }

        resultset.close();
        return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
    }

    public String getTimeDateFunctions()
        throws SQLException
    {
        Driver.debug("getTimeDateFunctions");
        return "";
    }

    public ResultSet getTypeInfo()
        throws SQLException
    {
        ResultSet resultset = connection.ExecSQL("select typname from pg_type");
        if(resultset != null)
        {
            Field afield[] = new Field[18];
            Vector vector = new Vector();
            afield[0] = new Field(connection, "TYPE_NAME", 1043, 32);
            afield[1] = new Field(connection, "DATA_TYPE", 21, 2);
            afield[2] = new Field(connection, "PRECISION", 23, 4);
            afield[3] = new Field(connection, "LITERAL_PREFIX", 1043, 32);
            afield[4] = new Field(connection, "LITERAL_SUFFIX", 1043, 32);
            afield[5] = new Field(connection, "CREATE_PARAMS", 1043, 32);
            afield[6] = new Field(connection, "NULLABLE", 21, 2);
            afield[7] = new Field(connection, "CASE_SENSITIVE", 16, 1);
            afield[8] = new Field(connection, "SEARCHABLE", 21, 2);
            afield[9] = new Field(connection, "UNSIGNED_ATTRIBUTE", 16, 1);
            afield[10] = new Field(connection, "FIXED_PREC_SCALE", 16, 1);
            afield[11] = new Field(connection, "AUTO_INCREMENT", 16, 1);
            afield[12] = new Field(connection, "LOCAL_TYPE_NAME", 1043, 32);
            afield[13] = new Field(connection, "MINIMUM_SCALE", 21, 2);
            afield[14] = new Field(connection, "MAXIMUM_SCALE", 21, 2);
            afield[15] = new Field(connection, "SQL_DATA_TYPE", 23, 4);
            afield[16] = new Field(connection, "SQL_DATETIME_SUB", 23, 4);
            afield[17] = new Field(connection, "NUM_PREC_RADIX", 23, 4);
            byte abyte0[] = "9".getBytes();
            byte abyte1[] = "10".getBytes();
            byte abyte2[] = "f".getBytes();
            byte abyte3[] = Integer.toString(0).getBytes();
            byte abyte4[] = Integer.toString(3).getBytes();
            byte abyte5[][];
            for(; resultset.next(); vector.addElement(abyte5))
            {
                abyte5 = new byte[18][];
                String s = resultset.getString(1);
                abyte5[0] = s.getBytes();
                abyte5[1] = Integer.toString(connection.getSQLType(s)).getBytes();
                abyte5[2] = abyte0;
                abyte5[6] = abyte3;
                abyte5[7] = abyte2;
                abyte5[8] = abyte4;
                abyte5[9] = abyte2;
                abyte5[10] = abyte2;
                abyte5[11] = abyte2;
                abyte5[17] = abyte1;
            }

            resultset.close();
            return new org.postgresql.jdbc2.ResultSet(connection, afield, vector, "OK", 1);
        } else
        {
            throw new PSQLException("postgresql.metadata.unavailable");
        }
    }

    public ResultSet getUDTs(String s, String s1, String s2, int ai[])
        throws SQLException
    {
        throw Driver.notImplemented();
    }

    public String getURL()
        throws SQLException
    {
        String s = connection.getURL();
        Driver.debug("getURL " + s);
        return s;
    }

    public String getUserName()
        throws SQLException
    {
        String s = connection.getUserName();
        Driver.debug("getUserName " + s);
        return s;
    }

    public ResultSet getVersionColumns(String s, String s1, String s2)
        throws SQLException
    {
        throw Driver.notImplemented();
    }

    public boolean insertsAreDetected(int i)
        throws SQLException
    {
        return false;
    }

    public boolean isCatalogAtStart()
        throws SQLException
    {
        Driver.debug("isCatalogAtStart not implemented");
        return true;
    }

    public boolean isReadOnly()
        throws SQLException
    {
        boolean flag = connection.isReadOnly();
        Driver.debug("isReadOnly " + flag);
        return flag;
    }

    public boolean nullPlusNonNullIsNull()
        throws SQLException
    {
        Driver.debug("nullPlusNonNullIsNull true");
        return true;
    }

    public boolean nullsAreSortedAtEnd()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("7.2") ^ true;
        Driver.debug("nullsAreSortedAtEnd " + flag);
        return flag;
    }

    public boolean nullsAreSortedAtStart()
        throws SQLException
    {
        Driver.debug("nullsAreSortedAtStart false");
        return false;
    }

    public boolean nullsAreSortedHigh()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("7.2");
        Driver.debug("nullsAreSortedHigh " + flag);
        return flag;
    }

    public boolean nullsAreSortedLow()
        throws SQLException
    {
        Driver.debug("nullsAreSortedLow false");
        return false;
    }

    public boolean othersDeletesAreVisible(int i)
        throws SQLException
    {
        return false;
    }

    public boolean othersInsertsAreVisible(int i)
        throws SQLException
    {
        return false;
    }

    public boolean othersUpdatesAreVisible(int i)
        throws SQLException
    {
        return false;
    }

    public boolean ownDeletesAreVisible(int i)
        throws SQLException
    {
        return false;
    }

    public boolean ownInsertsAreVisible(int i)
        throws SQLException
    {
        return false;
    }

    public boolean ownUpdatesAreVisible(int i)
        throws SQLException
    {
        return false;
    }

    public boolean rowChangesAreDetected(int i)
        throws SQLException
    {
        return false;
    }

    public boolean rowChangesAreVisible(int i)
        throws SQLException
    {
        return false;
    }

    public boolean storesLowerCaseIdentifiers()
        throws SQLException
    {
        Driver.debug("storesLowerCaseIdentifiers true");
        return true;
    }

    public boolean storesLowerCaseQuotedIdentifiers()
        throws SQLException
    {
        Driver.debug("storesLowerCaseQuotedIdentifiers false");
        return false;
    }

    public boolean storesMixedCaseIdentifiers()
        throws SQLException
    {
        Driver.debug("storesMixedCaseIdentifiers false");
        return false;
    }

    public boolean storesMixedCaseQuotedIdentifiers()
        throws SQLException
    {
        Driver.debug("storesMixedCaseQuotedIdentifiers false");
        return false;
    }

    public boolean storesUpperCaseIdentifiers()
        throws SQLException
    {
        Driver.debug("storesUpperCaseIdentifiers false");
        return false;
    }

    public boolean storesUpperCaseQuotedIdentifiers()
        throws SQLException
    {
        Driver.debug("storesUpperCaseQuotedIdentifiers false");
        return false;
    }

    public boolean supportsANSI92EntryLevelSQL()
        throws SQLException
    {
        Driver.debug("supportsANSI92EntryLevelSQL false ");
        return false;
    }

    public boolean supportsANSI92FullSQL()
        throws SQLException
    {
        Driver.debug("supportsANSI92FullSQL false ");
        return false;
    }

    public boolean supportsANSI92IntermediateSQL()
        throws SQLException
    {
        Driver.debug("supportsANSI92IntermediateSQL false ");
        return false;
    }

    public boolean supportsAlterTableWithAddColumn()
        throws SQLException
    {
        Driver.debug("supportsAlterTableWithAddColumn true");
        return true;
    }

    public boolean supportsAlterTableWithDropColumn()
        throws SQLException
    {
        Driver.debug("supportsAlterTableWithDropColumn false");
        return false;
    }

    public boolean supportsBatchUpdates()
        throws SQLException
    {
        return true;
    }

    public boolean supportsCatalogsInDataManipulation()
        throws SQLException
    {
        Driver.debug("supportsCatalogsInDataManipulation false");
        return false;
    }

    public boolean supportsCatalogsInIndexDefinitions()
        throws SQLException
    {
        Driver.debug("supportsCatalogsInIndexDefinitions false");
        return false;
    }

    public boolean supportsCatalogsInPrivilegeDefinitions()
        throws SQLException
    {
        Driver.debug("supportsCatalogsInPrivilegeDefinitions false");
        return false;
    }

    public boolean supportsCatalogsInProcedureCalls()
        throws SQLException
    {
        Driver.debug("supportsCatalogsInDataManipulation false");
        return false;
    }

    public boolean supportsCatalogsInTableDefinitions()
        throws SQLException
    {
        Driver.debug("supportsCatalogsInTableDefinitions false");
        return false;
    }

    public boolean supportsColumnAliasing()
        throws SQLException
    {
        Driver.debug("supportsColumnAliasing true");
        return true;
    }

    public boolean supportsConvert()
        throws SQLException
    {
        Driver.debug("supportsConvert false");
        return false;
    }

    public boolean supportsConvert(int i, int j)
        throws SQLException
    {
        Driver.debug("supportsConvert false");
        return false;
    }

    public boolean supportsCoreSQLGrammar()
        throws SQLException
    {
        Driver.debug("supportsCoreSQLGrammar FALSE ");
        return false;
    }

    public boolean supportsCorrelatedSubqueries()
        throws SQLException
    {
        return connection.haveMinimumServerVersion("7.1");
    }

    public boolean supportsDataDefinitionAndDataManipulationTransactions()
        throws SQLException
    {
        return true;
    }

    public boolean supportsDataManipulationTransactionsOnly()
        throws SQLException
    {
        return false;
    }

    public boolean supportsDifferentTableCorrelationNames()
        throws SQLException
    {
        Driver.debug("supportsDifferentTableCorrelationNames false");
        return false;
    }

    public boolean supportsExpressionsInOrderBy()
        throws SQLException
    {
        Driver.debug("supportsExpressionsInOrderBy true");
        return true;
    }

    public boolean supportsExtendedSQLGrammar()
        throws SQLException
    {
        Driver.debug("supportsExtendedSQLGrammar FALSE");
        return false;
    }

    public boolean supportsFullOuterJoins()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("7.1");
        Driver.debug("supportsFullOuterJoins " + flag);
        return flag;
    }

    public boolean supportsGroupBy()
        throws SQLException
    {
        Driver.debug("supportsGroupBy true");
        return true;
    }

    public boolean supportsGroupByBeyondSelect()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("6.4");
        Driver.debug("supportsGroupByUnrelated " + flag);
        return flag;
    }

    public boolean supportsGroupByUnrelated()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("6.4");
        Driver.debug("supportsGroupByUnrelated " + flag);
        return flag;
    }

    public boolean supportsIntegrityEnhancementFacility()
        throws SQLException
    {
        Driver.debug("supportsIntegrityEnhancementFacility false ");
        return false;
    }

    public boolean supportsLikeEscapeClause()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("7.1");
        Driver.debug("supportsLikeEscapeClause " + flag);
        return flag;
    }

    public boolean supportsLimitedOuterJoins()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("7.1");
        Driver.debug("supportsFullOuterJoins " + flag);
        return flag;
    }

    public boolean supportsMinimumSQLGrammar()
        throws SQLException
    {
        Driver.debug("supportsMinimumSQLGrammar TRUE");
        return true;
    }

    public boolean supportsMixedCaseIdentifiers()
        throws SQLException
    {
        Driver.debug("supportsMixedCaseIdentifiers false");
        return false;
    }

    public boolean supportsMixedCaseQuotedIdentifiers()
        throws SQLException
    {
        Driver.debug("supportsMixedCaseQuotedIdentifiers true");
        return true;
    }

    public boolean supportsMultipleResultSets()
        throws SQLException
    {
        Driver.debug("supportsMultipleResultSets false");
        return false;
    }

    public boolean supportsMultipleTransactions()
        throws SQLException
    {
        Driver.debug("supportsMultipleTransactions true");
        return true;
    }

    public boolean supportsNonNullableColumns()
        throws SQLException
    {
        Driver.debug("supportsNonNullableColumns true");
        return true;
    }

    public boolean supportsOpenCursorsAcrossCommit()
        throws SQLException
    {
        return false;
    }

    public boolean supportsOpenCursorsAcrossRollback()
        throws SQLException
    {
        return false;
    }

    public boolean supportsOpenStatementsAcrossCommit()
        throws SQLException
    {
        return true;
    }

    public boolean supportsOpenStatementsAcrossRollback()
        throws SQLException
    {
        return true;
    }

    public boolean supportsOrderByUnrelated()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("6.4");
        Driver.debug("supportsOrderByUnrelated " + flag);
        return flag;
    }

    public boolean supportsOuterJoins()
        throws SQLException
    {
        boolean flag = connection.haveMinimumServerVersion("7.1");
        Driver.debug("supportsOuterJoins " + flag);
        return flag;
    }

    public boolean supportsPositionedDelete()
        throws SQLException
    {
        Driver.debug("supportsPositionedDelete false");
        return false;
    }

    public boolean supportsPositionedUpdate()
        throws SQLException
    {
        Driver.debug("supportsPositionedUpdate false");
        return false;
    }

    public boolean supportsResultSetConcurrency(int i, int j)
        throws SQLException
    {
        if(i == 1005)
            return false;
        return j != 1008;
    }

    public boolean supportsResultSetType(int i)
        throws SQLException
    {
        return i != 1005;
    }

    public boolean supportsSchemasInDataManipulation()
        throws SQLException
    {
        Driver.debug("supportsSchemasInDataManipulation false");
        return false;
    }

    public boolean supportsSchemasInIndexDefinitions()
        throws SQLException
    {
        Driver.debug("supportsSchemasInIndexDefinitions false");
        return false;
    }

    public boolean supportsSchemasInPrivilegeDefinitions()
        throws SQLException
    {
        Driver.debug("supportsSchemasInPrivilegeDefinitions false");
        return false;
    }

    public boolean supportsSchemasInProcedureCalls()
        throws SQLException
    {
        Driver.debug("supportsSchemasInProcedureCalls false");
        return false;
    }

    public boolean supportsSchemasInTableDefinitions()
        throws SQLException
    {
        Driver.debug("supportsSchemasInTableDefinitions false");
        return false;
    }

    public boolean supportsSelectForUpdate()
        throws SQLException
    {
        return connection.haveMinimumServerVersion("6.5");
    }

    public boolean supportsStoredProcedures()
        throws SQLException
    {
        return false;
    }

    public boolean supportsSubqueriesInComparisons()
        throws SQLException
    {
        return true;
    }

    public boolean supportsSubqueriesInExists()
        throws SQLException
    {
        return true;
    }

    public boolean supportsSubqueriesInIns()
        throws SQLException
    {
        return true;
    }

    public boolean supportsSubqueriesInQuantifieds()
        throws SQLException
    {
        return true;
    }

    public boolean supportsTableCorrelationNames()
        throws SQLException
    {
        Driver.debug("supportsTableCorrelationNames true");
        return true;
    }

    public boolean supportsTransactionIsolationLevel(int i)
        throws SQLException
    {
        return i == 8 || i == 2;
    }

    public boolean supportsTransactions()
        throws SQLException
    {
        return true;
    }

    public boolean supportsUnion()
        throws SQLException
    {
        return true;
    }

    public boolean supportsUnionAll()
        throws SQLException
    {
        return connection.haveMinimumServerVersion("7.1");
    }

    public boolean updatesAreDetected(int i)
        throws SQLException
    {
        return false;
    }

    public boolean usesLocalFilePerTable()
        throws SQLException
    {
        Driver.debug("usesLocalFilePerTable false");
        return false;
    }

    public boolean usesLocalFiles()
        throws SQLException
    {
        Driver.debug("usesLocalFiles false");
        return false;
    }

}
